
<body>
  <table>
    <tr><br></tr>
    <tr id='bottomRow'>
      <td id='info' colspan="3">
        <div style="text-align: center;">
          <img src="/assets/images/robocup.png" style="height: 50px;"/>
          <h1 style="margin-bottom: 5px;">
            Erebus Robot Customisation 2023
          </h1>
          <span>Ver. 23.0.1</span>
          <h2 class="budget">
            Budget: {{budget}} &nbsp;&nbsp;Cost: {{cost}}
          </h2>
        </div>
        
        <app-threejs-render [deviceUpdate]=this.renderDeviceUpdate></app-threejs-render>

        <div id="axisHelpText">
          Axis Help - <span id="x_axis">X: Red</span>, <span id="y_axis">Y: Green</span>, <span id="z_axis">Z: Blue</span>
        </div>
        <br>
        <div id="file">
          <label>File Name: </label>
          <input #fileNameInput class="input" value="{{fileName}}">
          <button mat-raised-button color="primary" (click)="export_to_json()">Export to Json</button>
          <br>
          <br>
          <button mat-raised-button color="primary" (click)="jsonInput.click()">Import from Json</button>
          <input hidden (change)="jsonSelected($event)" #jsonInput type="file" id="file" onclick="this.value = null">
        </div>
        <br>
      </td>
      <td colspan="2">
        <h2>Sensors:</h2>
        <div *ngFor="let item of components">
          <app-component-checkbox [import]=checkboxImport[item.dictName] [values]=checkboxValues[item.dictName] [customName]="item.defaultName" [dictName]="item.dictName" [type]="item.type" [cost]="item.cost" [name]="item.name" [totalCost]="cost" [budget]="budget" (outputCost)="checkBoxChecked($event)" (component)="addRenderDevice($event)"></app-component-checkbox>
        </div>
        <br>
      </td>
      <td colspan="2">
        <h2>Distance Sensors ({{distCost}}): </h2>
        <label>Number of Distance Sensors</label><mat-slider type="range" max="8" min="0" value="{{numberOfDists}}" (input)="onDistSliderChange($event)"> </mat-slider>
        <br>
        <br>
        <div *ngFor="let dist of distsIterator; let j = index">
          <app-component-slider [values]=distanceSensorValues[j] [zxmax]=370 [name]="'Distance Sensor'" [number]="j + 1" (component)="addRenderDevice($event)"></app-component-slider>
        </div>
      </td>
      <td colspan="2">
        <h2>Wheels ({{wheelCost}}):</h2>
        <label>Number of Wheels</label><mat-slider type="range" max="4" min="1" value="{{numberOfWheels}}" (input)="onWheelSliderChange($event)"></mat-slider>
        <br>
        <br>
        <div *ngFor="let item of wheelsIterator; let i = index">
          <app-component-slider [values]=wheelSensorValues[i] [zxmax]=260 [name]="'Wheel'" [number]="i + 1" [wheel]=true (component)="addRenderDevice($event)"></app-component-slider>
        </div>
      </td>
      
    </tr>
  </table>
  <footer id="help_text">
    <div class="warning_child warning_symbol">&#9888;</div>
    <div class="warning_child">
      <b>This version of the robot customisation only works with Erebus v23.0.0+ and Webots 2023a.</b> Please make sure you download the correct Erebus and Webots versions before generating robots.
      <br>
      If you need to use previous version of Erebus, please use the corresponding version of Robot Customiser: 
      <select name="select" onChange="location.href=value;">
        <option value="#">v23.x.x</option>
        <option value="https://v21.robot.erebus.rcj.cloud">v21.x.x</option>
      </select>
    </div>
  </footer>
</body>